'use strict';

var builders = require('../ast/builders.cjs');
var internalScope = require('./internal-scope.cjs');
var scope = require('./scope.cjs');

function generateTreeMethodCall(id, state, needsShorthand) {
  const params =
    state === null ? [scope.default._] : [scope.default._, state.declarations[0].id];

  if (needsShorthand) {
    params.push(internalScope.default.shorthands);
  }

  return builders.expressionStatement(
    builders.callExpression(builders.memberExpression(internalScope.default.tree, id, true), params),
  );
}

exports.generateTreeMethodCall = generateTreeMethodCall;
