'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var builders = require('../../ast/builders.cjs');

function commonjs (runtimeDependencies, program) {
  program.body.unshift(
    builders.expressionStatement(builders.stringLiteral('use strict')),
    builders.variableDeclaration('const', [
      builders.variableDeclarator(
        builders.objectExpression(
          runtimeDependencies.map(([imported, local]) =>
            builders.objectProperty(
              builders.identifier(imported),
              builders.identifier(local),
              false,
              imported === local,
            ),
          ),
        ),
        builders.callExpression(builders.identifier('require'), [
          builders.stringLiteral('nimma/runtime'),
        ]),
      ),
    ]),
  );

  program.body[program.body.length - 1] = builders.expressionStatement(
    builders.assignmentExpression(
      '=',
      builders.memberExpression(builders.identifier('module'), builders.identifier('exports')),
      program.body[program.body.length - 1],
    ),
  );

  return program;
}

exports.default = commonjs;
